#include <limits.h>

unsigned int bin_search(unsigned int a [], unsigned int a_len, unsigned int key)
{
    
  unsigned int lo= 0;
  unsigned int hi= a_len;
  unsigned int mid;
  
  while (lo <= hi) 
     {
      mid= (lo+ hi)/2;
      if (a[mid] < key) lo= mid+1;
      else hi= mid;
    }
   
  if (!(lo < a_len && a[lo] == key)) lo= UINT_MAX;
  
  return lo;
  
}
